OpenEL 3.0.0

Classes | Macros | Typedefs | Enumerations | Functions | Variables
openEL.h File Reference

OpenEL Common Header File 3.0.0. More...

`#include <stdint.h>`
`#include "openEL_profCnf.h"`

Go to the source code of this file.

## Classes
struct | HALId
struct | Property
struct | HALObserver
struct | HALComponent
struct | TimerObserver
struct | EventTimer
struct | PositionControlActuator
struct | VelocityControlActuator
struct | TorqueControlActuator
struct | TorqueSensor
union | HalComponent
struct | elGenaralFncTblSt
union | elCommonFncTbl
struct | elPort_st
struct | elCompoTbl_st

## Macros
#define | OPENEL_MAJOR 3
#define | OPENEL_MINOR 0
#define | OPENEL_PATCHLEVEL 0
#define | OPENEL_VERSION "OpenEL 3.0.0"
#define | HALCOMPONENT_MEMBER
#define | EL_SW_COMPOMENT_PROPERTY_TABLE 1
#define | EL_PORT_ID_MAX (16)
#define | EL_SW_COMPONENT_PROPERTY_HEADER 1

## Typedefs
typedef float | float32_t
typedef double | float64_t
typedef float32_t | halfloat
typedef struct HALId | HALID_T
typedef struct Property | PROPERTY_T
typedef union HalComponent | HALCOMPONENT_T
typedef struct HALObserver | HALOBSERVER_T
typedef struct HALComponent | HALCOMPONENT_CORE_T
typedef struct EventTimer | EVENTTIMER_T
typedef struct TimerObserver | TIMEROBSERVER_T
typedef struct PositionControlActuator | POSITIONCONTROLACTUATOR_T
typedef struct VelocityControlActuator | VELOCITYCONTROLACTUATOR_T
typedef struct TorqueControlActuator | TORQUECONTROLACTUATOR_T
typedef struct TorqueSensor | TORQUESENSOR_T
typedef struct elGenaralFncTblSt | EL_GENERAL_FNC_TBL_T
typedef union elCommonFncTbl | EL_CMN_FNC_TBL_T

## Enumerations
enum | ReturnCode { HAL_OK = 0, HAL_ERROR }

## Functions
enum ReturnCode | HalInit (HALCOMPONENT_T *halComponent)
enum ReturnCode | HalReInit (HALCOMPONENT_T *halComponent)
enum ReturnCode | HalFinalize (HALCOMPONENT_T *halComponent)
enum ReturnCode | HalAddObserver (HALCOMPONENT_T *halComponent, HALOBSERVER_T *halObserver)
enum ReturnCode | HalRemoveObserver (HALCOMPONENT_T *halComponent, HALOBSERVER_T *halObserver)
enum ReturnCode | HalGetProperty (HALCOMPONENT_T *halComponent, PROPERTY_T *property)
enum ReturnCode | HalGetTime (HALCOMPONENT_T *halComponent, int32_t *time)
enum ReturnCode | HalEventTimerStartTimer (EVENTTIMER_T *eventTimer)
enum ReturnCode | HalEventTimerStopTimer (EVENTTIMER_T *eventTimer)
enum ReturnCode | HalEventTimerSetEventPeriod (EVENTTIMER_T *eventTimer, int32_t eventPeriod)
enum ReturnCode | HalEventTimerAddObserver (EVENTTIMER_T *eventTimer, TIMEROBSERVER_T *timerObserver)
enum ReturnCode | HalEventTimerRemoveObserver (EVENTTIMER_T *eventTimer, TIMEROBSERVER_T *timerObserver)
enum ReturnCode | HalSetPosition (HALCOMPONENT_T *positionControlActuator, halfloat position)
enum ReturnCode | HalGetPosition (HALCOMPONENT_T *positionControlActuator, halfloat *position)
enum ReturnCode | HalSetVelocity (HALCOMPONENT_T *velocityControlActuator, halfloat velocity)
enum ReturnCode | HalGetVelocity (HALCOMPONENT_T *velocityControlActuator, halfloat *velocity)
enum ReturnCode | HalSetTorque (HALCOMPONENT_T *torqueControlActuator, halfloat torque)
enum ReturnCode | HalGetTorque (HALCOMPONENT_T *torqueControlActuator, halfloat *torque)
enum ReturnCode | HalTorqueSensorGetValue (HALCOMPONENT_T *torqueSensor, halfloat *list)
enum ReturnCode | HalTorqueSensorGetTimedValue (HALCOMPONENT_T *torqueSensor, halfloat *list, int32_t *timer)
enum ReturnCode | HalTorqueSensorSetUnit (HALCOMPONENT_T *torqueSensor, char units)
enum ReturnCode | HalTorqueSensorGetUnit (HALCOMPONENT_T *torqueSensor, char *units)
enum ReturnCode | HalTorqueSensorSetReset (HALCOMPONENT_T *torqueSensor)
enum ReturnCode | HalTorqueSensorStart (HALCOMPONENT_T *torqueSensor)
enum ReturnCode | HalTorqueSensorStop (HALCOMPONENT_T *torqueSensor)
enum ReturnCode | Dummy ()
int32_t | elGetPhyicalPortID (uint32_t portID, uint32_t PropertyID)

## Variables
const uint32_t | elSzCompoTbl
const struct elCompoTbl_st | elCompoTbl []

## Detailed Description

OpenEL Common Header File 3.0.0.

Definition in file openEL.h.

## Macro Definition Documentation

## ◆ EL_PORT_ID_MAX

#define EL_PORT_ID_MAX (16)

Definition at line 237 of file openEL.h.

## ◆ EL_SW_COMPOMENT_PROPERTY_TABLE

#define EL_SW_COMPOMENT_PROPERTY_TABLE 1

Definition at line 216 of file openEL.h.

## ◆ EL_SW_COMPONENT_PROPERTY_HEADER

#define EL_SW_COMPONENT_PROPERTY_HEADER 1

Definition at line 252 of file openEL.h.

## ◆ HALCOMPONENT_MEMBER

#define HALCOMPONENT_MEMBER

Value:
int32_t handle; \
HALID_T halId;\
PROPERTY_T property;\
HALOBSERVER_T observerList[8];\
int32_t time;

Definition at line 80 of file openEL.h.

## ◆ OPENEL_MAJOR

#define OPENEL_MAJOR 3

Definition at line 38 of file openEL.h.

## ◆ OPENEL_MINOR

#define OPENEL_MINOR 0

Definition at line 39 of file openEL.h.

## ◆ OPENEL_PATCHLEVEL

#define OPENEL_PATCHLEVEL 0

Definition at line 40 of file openEL.h.

## ◆ OPENEL_VERSION

#define OPENEL_VERSION "OpenEL 3.0.0"

Definition at line 41 of file openEL.h.

## Typedef Documentation

## ◆ EL_CMN_FNC_TBL_T

typedef union elCommonFncTbl EL_CMN_FNC_TBL_T

function table universal

## ◆ EL_GENERAL_FNC_TBL_T

typedef struct elGenaralFncTblSt EL_GENERAL_FNC_TBL_T

general component — function table

## ◆ EVENTTIMER_T

typedef struct EventTimer EVENTTIMER_T

Definition at line 99 of file openEL.h.

## ◆ float32_t

typedef float float32_t

Definition at line 50 of file openEL.h.

## ◆ float64_t

typedef double float64_t

Definition at line 51 of file openEL.h.

## ◆ HALCOMPONENT_CORE_T

typedef struct HALComponent HALCOMPONENT_CORE_T

## ◆ HALCOMPONENT_T

typedef union HalComponent HALCOMPONENT_T

Definition at line 71 of file openEL.h.

## ◆ halfloat

typedef float32_t halfloat

Definition at line 53 of file openEL.h.

## ◆ HALID_T

typedef struct HALId HALID_T

## ◆ HALOBSERVER_T

typedef struct HALObserver HALOBSERVER_T

Definition at line 78 of file openEL.h.

## ◆ POSITIONCONTROLACTUATOR_T

typedef struct PositionControlActuator POSITIONCONTROLACTUATOR_T

## ◆ PROPERTY_T

typedef struct Property PROPERTY_T

## ◆ TIMEROBSERVER_T

typedef struct TimerObserver TIMEROBSERVER_T

## ◆ TORQUECONTROLACTUATOR_T

typedef struct TorqueControlActuator TORQUECONTROLACTUATOR_T

## ◆ TORQUESENSOR_T

typedef struct TorqueSensor TORQUESENSOR_T

## ◆ VELOCITYCONTROLACTUATOR_T

typedef struct VelocityControlActuator VELOCITYCONTROLACTUATOR_T

## Enumeration Type Documentation

## ◆ ReturnCode

enum ReturnCode

Enumerator
HAL_OK |
HAL_ERROR |

Definition at line 44 of file openEL.h.

## Function Documentation

## ◆ Dummy()

enum ReturnCode Dummy | ( |  | ) |

Definition at line 82 of file openEL_0000000012345678.c.

## ◆ elGetPhyicalPortID()

int32_t elGetPhyicalPortID | ( | uint32_t | handle,
|  | uint32_t | profileID
| ) |  |

物理portIDに変換

物理handleに変換

Definition at line 196 of file openEL.c.

## ◆ HalAddObserver()

enum ReturnCode HalAddObserver | ( | HALCOMPONENT_T * | halComponent,
|  | HALOBSERVER_T * | halObserver
| ) |  |

Definition at line 146 of file openEL.c.

## ◆ HalEventTimerAddObserver()

enum ReturnCode HalEventTimerAddObserver | ( | EVENTTIMER_T * | eventTimer,
|  | TIMEROBSERVER_T * | timerObserver
| ) |  |

Definition at line 183 of file openEL.c.

## ◆ HalEventTimerRemoveObserver()

enum ReturnCode HalEventTimerRemoveObserver | ( | EVENTTIMER_T * | eventTimer,
|  | TIMEROBSERVER_T * | timerObserver
| ) |  |

Definition at line 189 of file openEL.c.

## ◆ HalEventTimerSetEventPeriod()

enum ReturnCode HalEventTimerSetEventPeriod | ( | EVENTTIMER_T * | eventTimer,
|  | int32_t | eventPeriod
| ) |  |

Definition at line 178 of file openEL.c.

## ◆ HalEventTimerStartTimer()

enum ReturnCode HalEventTimerStartTimer | ( | EVENTTIMER_T * | eventTimer | ) |

Definition at line 167 of file openEL.c.

## ◆ HalEventTimerStopTimer()

enum ReturnCode HalEventTimerStopTimer | ( | EVENTTIMER_T * | eventTimer | ) |

Definition at line 173 of file openEL.c.

## ◆ HalFinalize()

enum ReturnCode HalFinalize | ( | HALCOMPONENT_T * | halComponent | ) |

OpenELデバイスの終了

Definition at line 130 of file openEL.c.

## ◆ HalGetPosition()

enum ReturnCode HalGetPosition | ( | HALCOMPONENT_T * | halComponent,
|  | halfloat * | position
| ) |  |

OpenELモーター 位置の取得(I32)

Parameters

  [in] | portID | : ポートID
  [in] | idx | : 0:現在の検出位置 / 1:指定された目標位置 / 2:現在の指令位置
  [out] | pOutPos |

Returns
  エラーコード 0:正常 / 0以外:異常 ユーザースレッド (ノンブロッキング)

Definition at line 69 of file openEL_motor.c.

## ◆ HalGetProperty()

enum ReturnCode HalGetProperty | ( | HALCOMPONENT_T * | halComponent,
|  | PROPERTY_T * | property
| ) |  |

Definition at line 157 of file openEL.c.

## ◆ HalGetTime()

enum ReturnCode HalGetTime | ( | HALCOMPONENT_T * | halComponent,
|  | int32_t * | time
| ) |  |

Definition at line 162 of file openEL.c.

## ◆ HalGetTorque()

enum ReturnCode HalGetTorque | ( | HALCOMPONENT_T * | torqueControlActuator,
|  | halfloat * | torque
| ) |  |

## ◆ HalGetVelocity()

enum ReturnCode HalGetVelocity | ( | HALCOMPONENT_T * | velocityControlActuator,
|  | halfloat * | velocity
| ) |  |

## ◆ HalInit()

enum ReturnCode HalInit | ( | HALCOMPONENT_T * | halComponent | ) |

Initialize the openEL component

Parameters

  [in] | vendorID |
  [in] | productID |
  [in] | component | index

Returns
  0:OK / less than -1:error code

Definition at line 75 of file openEL.c.

## ◆ HalReInit()

enum ReturnCode HalReInit | ( | HALCOMPONENT_T * | halComponent | ) |

OpenELデバイスのリセット

Definition at line 114 of file openEL.c.

## ◆ HalRemoveObserver()

enum ReturnCode HalRemoveObserver | ( | HALCOMPONENT_T * | halComponent,
|  | HALOBSERVER_T * | halObserver
| ) |  |

Definition at line 152 of file openEL.c.

## ◆ HalSetPosition()

enum ReturnCode HalSetPosition | ( | HALCOMPONENT_T * | halComponent,
|  | halfloat | position
| ) |  |

OpenELモーター 位置決め運転

Parameters

  [in] | portID | : ポートID
  [in] | angle | : 絶対位置指令 [ユーザー単位]
  [in] | speed | : 速度 [ユーザー単位/s] 範囲 0より大きい～製品仕様
  [in] | tmAcc | : 加減速時間 [ms](I32),[s](F64) 0以上～製品仕様

Returns
  エラーコード 0:正常 / 0以外:異常(運転を受け付けられない状態) ユーザースレッド (ノンブロッキング) 速度、加減速時間を設定しない関数の場合はパラメーターに従う パラメーターID:16で浮動小数点にしている場合はエラー

Definition at line 41 of file openEL_motor.c.

## ◆ HalSetTorque()

enum ReturnCode HalSetTorque | ( | HALCOMPONENT_T * | torqueControlActuator,
|  | halfloat | torque
| ) |  |

## ◆ HalSetVelocity()

enum ReturnCode HalSetVelocity | ( | HALCOMPONENT_T * | velocityControlActuator,
|  | halfloat | velocity
| ) |  |

## ◆ HalTorqueSensorGetTimedValue()

enum ReturnCode HalTorqueSensorGetTimedValue | ( | HALCOMPONENT_T * | torqueSensor,
|  | halfloat * | list,
|  | int32_t * | timer
| ) |  |

Definition at line 46 of file openEL_sensor.c.

## ◆ HalTorqueSensorGetUnit()

enum ReturnCode HalTorqueSensorGetUnit | ( | HALCOMPONENT_T * | torqueSensor,
|  | char * | units
| ) |  |

## ◆ HalTorqueSensorGetValue()

enum ReturnCode HalTorqueSensorGetValue | ( | HALCOMPONENT_T * | torqueSensor,
|  | halfloat * | list
| ) |  |

Definition at line 30 of file openEL_sensor.c.

## ◆ HalTorqueSensorSetReset()

enum ReturnCode HalTorqueSensorSetReset | ( | HALCOMPONENT_T * | torqueSensor | ) |

## ◆ HalTorqueSensorSetUnit()

enum ReturnCode HalTorqueSensorSetUnit | ( | HALCOMPONENT_T * | torqueSensor,
|  | char | units
| ) |  |

## ◆ HalTorqueSensorStart()

enum ReturnCode HalTorqueSensorStart | ( | HALCOMPONENT_T * | torqueSensor | ) |

## ◆ HalTorqueSensorStop()

enum ReturnCode HalTorqueSensorStop | ( | HALCOMPONENT_T * | torqueSensor | ) |

## Variable Documentation

## ◆ elCompoTbl

const struct elCompoTbl_st elCompoTbl[]

Component Table

Definition at line 31 of file openEL_compoCnf.c.

## ◆ elSzCompoTbl

const uint32_t elSzCompoTbl

Definition at line 49 of file openEL_compoCnf.c.